unit uContas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Mask, DBCtrls, ExtCtrls, ComCtrls, Grids,
  DBGrids, DB, ADODB;

type
  TfrmContas = class(TForm)
    Panel1: TPanel;
    EditConta: TDBEdit;
    EditAgencia: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    StatusBar1: TStatusBar;
    Label4: TLabel;
    Panel3: TPanel;
    DBGrid1: TDBGrid;
    ConnectContas: TADOConnection;
    tbContas: TADOTable;
    dsContas: TDataSource;
    Panel4: TPanel;
    btnSalvar: TBitBtn;
    btnCancelar: TBitBtn;
    btnExcluir: TBitBtn;
    btnEditar: TBitBtn;
    btnSair: TBitBtn;
    EditIDConta: TDBEdit;
    Label5: TLabel;
    DBNavigator1: TDBNavigator;
    btnNovo: TBitBtn;
    EditBanco: TDBLookupComboBox;
    tbBancos: TADOTable;
    dsBancos: TDataSource;
    DBEdit1: TDBEdit;
    tbContasID_Conta: TIntegerField;
    tbContasAgencia: TWideStringField;
    tbContasConta: TWideStringField;
    tbContasBanco: TWideStringField;
    tbBancosCODIGO_BANCO: TWideStringField;
    tbBancosNOME_BANCO: TWideStringField;
    tbBancosMASCARA: TWideStringField;
    tbBancosOBS: TWideStringField;
    procedure FormCreate(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnExcluirClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure EditContaKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmContas: TfrmContas;
  Local:String;
  OldVal:Integer;

implementation

{$R *.dfm}

procedure TfrmContas.FormCreate(Sender: TObject);
begin
  tbContas.Close;
  tbBancos.Close;
  Local:=ExtractFilePath(Application.ExeName);
  ConnectContas.Connected:=False;
  ConnectContas.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Password="";User ID=Admin;Data Source='+ Local + '\Banco.mdb;';
  ConnectContas.Connected:=True;
  tbContas.TableName:='Contas';
  tbBancos.TableName:='Bancos';
  tbBancos.Open;
  tbContas.Open;
end;

procedure TfrmContas.btnNovoClick(Sender: TObject);
begin
EditConta.Enabled:=True;
EditAgencia.Enabled:=True;
EditBanco.Enabled:=True;
btnNovo.Enabled:=False;
btnCancelar.Enabled:=True;
btnSalvar.Enabled:=True;
tbContas.Last;
OldVal:=tbContasID_Conta.Value;
OldVal:=OldVal + 1;
tbContas.Insert;
tbContasID_Conta.Value:=OldVal;
tbBancos.Open;
end;

procedure TfrmContas.btnCancelarClick(Sender: TObject);
begin
if tbContas.State in [dsInsert, dsEdit] then begin
  btnNovo.Enabled:=True;
  btnCancelar.Enabled:=False;
  btnExcluir.Enabled:=True;
  btnSalvar.Enabled:=False;
  btnNovo.Enabled:=True;
  btnEditar.Enabled:=True;
  tbContas.Cancel;
end;
end;

procedure TfrmContas.btnEditarClick(Sender: TObject);
begin
btnNovo.Enabled:=False;
btnEditar.Enabled:=False;
btnCancelar.Enabled:=True;
btnSalvar.Enabled:=True;
btnExcluir.Enabled:=False;
EditConta.Enabled:=True;
EditAgencia.Enabled:=True;
EditBanco.Enabled:=True;
tbContas.Edit;
end;

procedure TfrmContas.btnExcluirClick(Sender: TObject);
begin
btnNovo.Enabled:=True;
btnEditar.Enabled:=True;
btnCancelar.Enabled:=False;
btnSalvar.Enabled:=False;
if not tbContas.IsEmpty then tbContas.Delete;
end;

procedure TfrmContas.btnSairClick(Sender: TObject);
begin
Close;
end;

procedure TfrmContas.btnSalvarClick(Sender: TObject);
begin
btnNovo.Enabled:=True;
btnSalvar.Enabled:=False;
btnEditar.Enabled:=True;
btnCancelar.Enabled:=True;
btnExcluir.Enabled:=True;
if tbContas.State in [dsEdit,dsInsert] then begin
  tbContas.Post;
end;
end;

procedure TfrmContas.EditContaKeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,'-'] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

end.
