unit UAgencias;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, DBGrids, DBCtrls, Mask, ExtCtrls, DB,
  ADODB;

type
  TfrmAgencias = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBNavigator1: TDBNavigator;
    DBComboBox1: TDBComboBox;
    DBLookupComboBox1: TDBLookupComboBox;
    DBEdit9: TDBEdit;
    DBGrid1: TDBGrid;
    Panel3: TPanel;
    btnNovo: TBitBtn;
    btnSalvar: TBitBtn;
    btnCancelar: TBitBtn;
    btnEditar: TBitBtn;
    btnExcluir: TBitBtn;
    btnFechar: TBitBtn;
    ConnectAgencias: TADOConnection;
    tbAgencias: TADOTable;
    tbAgenciasCodigo: TIntegerField;
    tbAgenciasCODIGO_AGENCIA: TWideStringField;
    tbAgenciasCODIGO_BANCO: TIntegerField;
    tbAgenciasNOME_BANCO: TWideStringField;
    tbAgenciasNOME_AGENCIA: TWideStringField;
    tbAgenciasCIDADE: TWideStringField;
    tbAgenciasUF: TWideStringField;
    tbAgenciasTELEFONE: TWideStringField;
    tbAgenciasRESPONSAVEL: TWideStringField;
    tbAgenciasOBS: TWideStringField;
    dsAgencias: TDataSource;
    dsBancos: TDataSource;
    tbBancos: TADOTable;
    tbBancosCODIGO_BANCO: TWideStringField;
    tbBancosNOME_BANCO: TWideStringField;
    tbBancosMASCARA: TWideStringField;
    tbBancosOBS: TWideStringField;
    procedure DBLookupComboBox1Click(Sender: TObject);
    procedure btnFecharClick(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnExcluirClick(Sender: TObject);
    procedure DBEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit6KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAgencias: TfrmAgencias;
  d:integer;
  OldValue:Integer;
  Local:String;


implementation

{$R *.dfm}

procedure TfrmAgencias.DBLookupComboBox1Click(Sender: TObject);
begin
tbAgenciasCODIGO_BANCO.Text:=tbBancosCODIGO_BANCO.Text;
btnSalvar.Enabled:=True;
btnCancelar.Enabled:=true;
end;

procedure TfrmAgencias.btnFecharClick(Sender: TObject);
begin
Close;
end;

procedure TfrmAgencias.btnNovoClick(Sender: TObject);
begin
btnSalvar.Enabled:=True;
btnCancelar.Enabled:=True;
btnExcluir.Enabled:=False;
btnEditar.Enabled:=False;
btnNovo.Enabled:=False;
tbAgencias.Last;
OldValue:=tbAgenciasCodigo.Value;
OldValue:=OldValue + 1;
tbAgencias.Insert;
tbAgenciasCodigo.Value:=OldValue;
end;

procedure TfrmAgencias.btnSalvarClick(Sender: TObject);
begin
btnNovo.Enabled:=True;
btnSalvar.Enabled:=False;
btnEditar.Enabled:=True;
btnCancelar.Enabled:=False;
btnExcluir.Enabled:=True;

if tbAgencias.State in [dsInsert,dsEdit] then tbAgencias.Post;

end;

procedure TfrmAgencias.btnCancelarClick(Sender: TObject);
begin
  btnNovo.Enabled:=True;
  btnCancelar.Enabled:=False;
  btnExcluir.Enabled:=True;
  btnSalvar.Enabled:=False;
  btnNovo.Enabled:=True;
  btnEditar.Enabled:=True;
if tbAgencias.State in [dsInsert,dsEdit] then tbAgencias.Cancel;
end;
procedure TfrmAgencias.btnEditarClick(Sender: TObject);
begin
btnNovo.Enabled:=False;
btnEditar.Enabled:=False;
btnCancelar.Enabled:=True;
btnSalvar.Enabled:=True;
btnExcluir.Enabled:=False;
tbAgencias.Edit;
end;

procedure TfrmAgencias.btnExcluirClick(Sender: TObject);
begin
btnNovo.Enabled:=True;
btnEditar.Enabled:=True;
btnCancelar.Enabled:=False;
btnSalvar.Enabled:=False;
if not tbAgencias.IsEmpty then tbAgencias.Delete;
end;

procedure TfrmAgencias.DBEdit2KeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,'-'] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

procedure TfrmAgencias.DBEdit6KeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

procedure TfrmAgencias.FormCreate(Sender: TObject);
begin
  tbAgencias.Close;
  tbBancos.Close;
  Local:=ExtractFilePath(Application.ExeName);
  ConnectAgencias.Connected:=False;
  ConnectAgencias.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Password="";User ID=Admin;Data Source='+ Local + '\Banco.mdb;';
  ConnectAgencias.Connected:=True;
  tbBancos.Open;
  tbAgencias.Open;
end;

end.
