unit UBancos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, DB, ADODB, StdCtrls, Mask, DBCtrls, Buttons;

type
  TfrmBancos = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    StatusBar1: TStatusBar;
    tbBancos: TADOTable;
    ConnectBancos: TADOConnection;
    dsBancos: TDataSource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    DBNavigator1: TDBNavigator;
    btnSalvar: TBitBtn;
    btnCancelar: TBitBtn;
    btnExcluir: TBitBtn;
    btnEditar: TBitBtn;
    btnSair: TBitBtn;
    btnNovo: TBitBtn;
    tbBancosCODIGO_BANCO: TWideStringField;
    tbBancosNOME_BANCO: TWideStringField;
    tbBancosMASCARA: TWideStringField;
    tbBancosOBS: TWideStringField;
    procedure btnSairClick(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnExcluirClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBancos: TfrmBancos;
  Local:String;

implementation

{$R *.dfm}

procedure TfrmBancos.btnSairClick(Sender: TObject);
begin
Close;
end;

procedure TfrmBancos.btnEditarClick(Sender: TObject);
begin
btnSalvar.Enabled:=True;
btnCancelar.Enabled:=True;
btnExcluir.Enabled:=False;
btnEditar.Enabled:=False;
btnNovo.Enabled:=False;
tbBancos.Edit;
end;

procedure TfrmBancos.btnExcluirClick(Sender: TObject);
begin
if not tbBancos.IsEmpty then tbBancos.Delete;
end;

procedure TfrmBancos.btnCancelarClick(Sender: TObject);
begin
btnSalvar.Enabled:=False;
btnCancelar.Enabled:=False;
btnExcluir.Enabled:=True;
btnEditar.Enabled:=True;
btnNovo.Enabled:=True;
tbBancos.Cancel;

end;

procedure TfrmBancos.btnSalvarClick(Sender: TObject);
begin
btnSalvar.Enabled:=False;
btnCancelar.Enabled:=False;
btnExcluir.Enabled:=True;
btnEditar.Enabled:=True;
btnNovo.Enabled:=True;
if tbBancos.State in [dsEdit,dsInsert] then tbBancos.Post;
end;

procedure TfrmBancos.btnNovoClick(Sender: TObject);
begin
btnSalvar.Enabled:=True;
btnCancelar.Enabled:=True;
btnExcluir.Enabled:=False;
btnEditar.Enabled:=False;
btnNovo.Enabled:=False;
tbBancos.Last;
tbBancos.Insert;
end;

procedure TfrmBancos.FormCreate(Sender: TObject);
begin
  tbBancos.Close;
  Local:=ExtractFilePath(Application.ExeName);
  ConnectBancos.Connected:=False;
  ConnectBancos.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Password="";User ID=Admin;Data Source='+ Local + '\Banco.mdb;';
  ConnectBancos.Connected:=True;
  tbBancos.Open;
end;

end.
