unit UEmitidos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Grids, DBGrids, DB, ADODB, StdCtrls, DBCtrls,
  Mask, Buttons;

type
  TfrmEmitidos = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    StatusBar1: TStatusBar;
    DBGrid1: TDBGrid;
    ConnectContas: TADOConnection;
    tbContas: TADOTable;
    tbContasID_Conta: TIntegerField;
    tbContasAgencia: TWideStringField;
    tbContasConta: TWideStringField;
    tbContasBanco: TWideStringField;
    dsContas: TDataSource;
    qrCheques: TADOQuery;
    tbCheques: TADOTable;
    dsCheques: TDataSource;
    tbChequesID_Cheque: TIntegerField;
    tbChequesConta: TWideStringField;
    tbChequesHistorico: TWideStringField;
    tbChequesDataEmissao: TWideStringField;
    tbChequesNumeroDocumento: TIntegerField;
    tbChequesDataVencimento: TWideStringField;
    tbChequesDataBaixa: TWideStringField;
    tbChequesValor: TBCDField;
    tbChequesStatus: TIntegerField;
    Label1: TLabel;
    DBGrid2: TDBGrid;
    Label2: TLabel;
    Panel4: TPanel;
    Panel5: TPanel;
    StatusBar2: TStatusBar;
    DBGrid3: TDBGrid;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    DBEdit4: TDBEdit;
    tbChequesAgencia: TWideStringField;
    tbChequesNumCheque: TIntegerField;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel6: TPanel;
    Label7: TLabel;
    BitBtn3: TBitBtn;
    DataBaixa: TDateTimePicker;
    DBEdit5: TDBEdit;
    Label8: TLabel;
    DataSource1: TDataSource;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    qrChequesID_Cheque: TIntegerField;
    qrChequesAgencia: TWideStringField;
    qrChequesNumCheque: TIntegerField;
    qrChequesConta: TWideStringField;
    qrChequesHistorico: TWideStringField;
    qrChequesDataEmissao: TWideStringField;
    qrChequesNumeroDocumento: TIntegerField;
    qrChequesDataVencimento: TWideStringField;
    qrChequesDataBaixa: TWideStringField;
    qrChequesValor: TBCDField;
    qrChequesStatus: TIntegerField;
    DBEdit6: TDBEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure DBGrid2CellClick(Column: TColumn);
    procedure BitBtn4Click(Sender: TObject);
    procedure RefreshBaixa;
    procedure BitBtn5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure tbChequesFilterRecord(DataSet: TDataSet;
      var Accept: Boolean);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit2KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmEmitidos: TfrmEmitidos;
  St:Boolean;
  Local:String;

implementation

{$R *.dfm}

procedure TfrmEmitidos.RefreshBaixa;
begin
  qrCheques.Close;
   With qrCheques do begin
   Sql.Clear;
   SQL.Add('select * from Cheques where  Status = 1'); 
   //ShowMessage(qrCheques.SQL.Text);
   Open;
   end;
end;

procedure TfrmEmitidos.BitBtn1Click(Sender: TObject);
begin
  Panel6.Visible:=True;
  tbCheques.Edit;
end;

procedure TfrmEmitidos.BitBtn2Click(Sender: TObject);
begin
if tbCheques.State in [dsEdit] then tbCheques.Post;
RefreshBaixa;
Panel4.Visible:=False;
end;

procedure TfrmEmitidos.BitBtn3Click(Sender: TObject);
begin
  Panel6.Visible:=False;
  tbCheques.Edit;
  tbChequesStatus.Value:=0;
  tbChequesDataBaixa.Value:=dbEdit5.Text;
  dbEdit5.Text:=DateToStr(DataBaixa.Date);
//  RefreshBaixa;  
end;

procedure TfrmEmitidos.DBGrid2CellClick(Column: TColumn);
begin
  RefreshBaixa;
end;

procedure TfrmEmitidos.BitBtn4Click(Sender: TObject);
begin
Panel4.Visible:=True;
end;

procedure TfrmEmitidos.BitBtn5Click(Sender: TObject);
begin
  tbCheques.Cancel;
  Panel4.Visible:=False;
  RefreshBaixa;
end;

procedure TfrmEmitidos.FormCreate(Sender: TObject);
begin
St:=False;
  tbContas.Close;
  tbCheques.Close;
  qrCheques.Close;
  Local:=ExtractFilePath(Application.ExeName);
  ConnectContas.Connected:=False;
  ConnectContas.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Password="";User ID=Admin;Data Source='+ Local + '\Banco.mdb;';
  ConnectContas.Connected:=True;
  tbContas.Close;
  tbCheques.Close;
  qrCheques.Open;
end;

procedure TfrmEmitidos.BitBtn6Click(Sender: TObject);
begin
Close;
end;

procedure TfrmEmitidos.tbChequesFilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
  var
  Estado:Integer;
begin
  Accept := false;
  Estado:=tbChequesStatus.Value;
//  DecodeDate(Table1['Competencia'],Ano,Mes,Dia);
  if Estado = 1 then
  Accept := True;
end;

procedure TfrmEmitidos.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,'-'] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

procedure TfrmEmitidos.DBEdit2KeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,'-'] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

end.
