unit uEmissao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, DBCtrls, Mask, DB, ADODB, Buttons,
  jpeg, Grids, DBGrids;

type
  TfrmCheques = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    EditDocumento: TDBEdit;
    EditHistorico: TDBEdit;
    EditEmissao: TDBEdit;
    EditVencimento: TDBEdit;
    EditValor: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ConnectContas: TADOConnection;
    tbCheques: TADOTable;
    dsCheques: TDataSource;
    btnNovo: TBitBtn;
    btnSalvar: TBitBtn;
    btnCancelar: TBitBtn;
    btnEditar: TBitBtn;
    btnExcluir: TBitBtn;
    btnFechar: TBitBtn;
    tbContas: TADOTable;
    dsContas: TDataSource;
    DBGrid1: TDBGrid;
    ComboConta: TDBLookupComboBox;
    tbChequesID_Cheque: TIntegerField;
    tbChequesConta: TWideStringField;
    tbChequesHistorico: TWideStringField;
    tbChequesDataEmissao: TWideStringField;
    tbChequesNumeroDocumento: TIntegerField;
    tbChequesDataVencimento: TWideStringField;
    tbChequesDataBaixa: TWideStringField;
    tbChequesValor: TBCDField;
    tbChequesStatus: TIntegerField;
    tbContasID_Conta: TIntegerField;
    tbContasAgencia: TWideStringField;
    tbContasConta: TWideStringField;
    tbContasBanco: TWideStringField;
    Label7: TLabel;
    tbChequesAgencia: TWideStringField;
    tbChequesNumCheque: TIntegerField;
    ComboAgencia: TDBLookupComboBox;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    Label8: TLabel;
    tbChequesObs: TWideStringField;
    DBEdit2: TDBEdit;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnFecharClick(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnExcluirClick(Sender: TObject);
    procedure Habilitar;
    procedure EditEmissaoKeyPress(Sender: TObject; var Key: Char);
    procedure EditVencimentoKeyPress(Sender: TObject; var Key: Char);
    procedure EditValorKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCheques: TfrmCheques;
  Local:String;
  St:Boolean;
  OldVal:Integer;

implementation

{$R *.dfm}
procedure TfrmCheques.Habilitar;
begin
  ComboConta.Enabled:=St;
  //EditDocumento.Enabled:=St;
  EditEmissao.Enabled:=St;
  EditHistorico.Enabled:=St;
  EditVencimento.Enabled:=St;
  EditValor.Enabled:=St;
  ComboAgencia.Enabled :=St;
//
end;
procedure TfrmCheques.FormCreate(Sender: TObject);
begin
  tbCheques.Close;
  tbContas.Close;
  Local:=ExtractFilePath(Application.ExeName);
  ConnectContas.Connected:=False;
  ConnectContas.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Password="";User ID=Admin;Data Source='+ Local + '\Banco.mdb;';
  ConnectContas.Connected:=True;
  tbContas.TableName:='Contas';
  tbCheques.TableName:='Cheques';
  tbContas.Open;
  tbCheques.Open;
end;

procedure TfrmCheques.btnFecharClick(Sender: TObject);
begin
Close;
end;

procedure TfrmCheques.btnNovoClick(Sender: TObject);
begin
St:=True;
Habilitar;
btnNovo.Enabled:=False;
btnCancelar.Enabled:=True;
btnSalvar.Enabled:=True;
//
tbCheques.Last;
OldVal:=tbChequesID_Cheque.Value;
OldVal:=OldVal + 1;
tbCheques.Insert;
tbChequesID_Cheque.Value:=OldVal;
tbChequesNumeroDocumento.Value:=OldVal;
tbChequesStatus.Value:=1;
end;

procedure TfrmCheques.btnSalvarClick(Sender: TObject);
begin
btnNovo.Enabled:=True;
btnSalvar.Enabled:=False;
btnEditar.Enabled:=True;
btnCancelar.Enabled:=False;
btnExcluir.Enabled:=True;
if tbCheques.State in [dsEdit,dsInsert] then begin
  tbCheques.Post;
  St:=False;
  Habilitar;
end;
end;

procedure TfrmCheques.btnCancelarClick(Sender: TObject);
begin
if tbCheques.State in [dsInsert, dsEdit] then begin
  St:=False;
  Habilitar;
  btnNovo.Enabled:=True;
  btnCancelar.Enabled:=False;
  btnExcluir.Enabled:=True;
  btnSalvar.Enabled:=False;
  btnNovo.Enabled:=True;
  btnEditar.Enabled:=True;
  tbCheques.Cancel;
end;
end;

procedure TfrmCheques.btnEditarClick(Sender: TObject);
begin
btnNovo.Enabled:=False;
btnEditar.Enabled:=False;
btnCancelar.Enabled:=True;
btnSalvar.Enabled:=True;
btnExcluir.Enabled:=False;
St:=True;
Habilitar;
tbCheques.Edit;
end;

procedure TfrmCheques.btnExcluirClick(Sender: TObject);
begin
btnNovo.Enabled:=True;
btnEditar.Enabled:=True;
btnCancelar.Enabled:=False;
btnSalvar.Enabled:=False;
if not tbCheques.IsEmpty then tbCheques.Delete;
end;

procedure TfrmCheques.EditEmissaoKeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

procedure TfrmCheques.EditVencimentoKeyPress(Sender: TObject;
  var Key: Char);
begin
  If not( key in['0'..'9',#8] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

procedure TfrmCheques.EditValorKeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,'.',','] ) then
  begin
//  beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

end.
