unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, ComCtrls, jpeg, DB, ADODB;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    Cadastro1: TMenuItem;
    Contas1: TMenuItem;
    N1: TMenuItem;
    Cheques1: TMenuItem;
    N2: TMenuItem;
    Usuarios1: TMenuItem;
    N3: TMenuItem;
    Relatorios1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Ajuda1: TMenuItem;
    N6: TMenuItem;
    Arquivo1: TMenuItem;
    N7: TMenuItem;
    Sair1: TMenuItem;
    ConsultarCheques1: TMenuItem;
    Pendentes1: TMenuItem;
    Emitidos1: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Baixados1: TMenuItem;
    TodososCheques1: TMenuItem;
    N10: TMenuItem;
    Emitidos2: TMenuItem;
    N11: TMenuItem;
    Baixados2: TMenuItem;
    N12: TMenuItem;
    Pendentes2: TMenuItem;
    Bancos1: TMenuItem;
    Sobre1: TMenuItem;
    N13: TMenuItem;
    Agncia1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    N14: TMenuItem;
    ConfigurarImpressora1: TMenuItem;
    Image1: TImage;
    StatusBar1: TStatusBar;
    procedure Sair1Click(Sender: TObject);
    procedure Contas1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Cheques1Click(Sender: TObject);
    procedure Emitidos1Click(Sender: TObject);
    procedure Baixados1Click(Sender: TObject);
    procedure Bancos1Click(Sender: TObject);
    procedure Agncia1Click(Sender: TObject);
    procedure TodososCheques1Click(Sender: TObject);
    procedure ConfigurarImpressora1Click(Sender: TObject);
    procedure Baixados2Click(Sender: TObject);
    procedure Pendentes2Click(Sender: TObject);
    procedure AbreTabela(x:Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  Local:String;

implementation

uses uContas, uEmissao, UEmitidos, UBaixados, UBancos, UAgencias,
  URelChCadastrados, UPendentes;

const
ScreenWidth: LongInt = 1024; {I designed my form in 800x600 mode.}
ScreenHeight: LongInt = 768;

{$R *.dfm}

procedure TfrmMain.AbreTabela(x:Integer);
begin
Case x of
1: frmRelCheques.ADOTable1.Close;
2: frmRelCheques.ADOTable2.Close;
3: frmRelCheques.ADOTable3.Close;
end;
  frmRelCheques.ADOConnection1.Connected:=False;
  frmRelCheques.ADOConnection1.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Password="";User ID=Admin;Data Source='+ Local + '\Banco.mdb;';
  frmRelCheques.ADOConnection1.Connected:=True;
Case x of
//  end;
1:  frmRelCheques.ADOTable1.Open;
2:  frmRelCheques.ADOTable2.Open;
3:  frmRelCheques.ADOTable3.Open;
end;
end;
procedure TfrmMain.Sair1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmMain.Contas1Click(Sender: TObject);
begin
frmContas:=TfrmContas.Create(Application);
frmContas.ShowModal;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
Local:=ExtractFilePath(Application.ExeName);
Image1.Align:=alClient;
   scaled := true;
   if (screen.width <> ScreenWidth) then
   begin
       height := longint(height) * longint(screen.height) DIV ScreenHeight;
       width := longint(width) * longint(screen.width) DIV ScreenWidth;
       scaleBy(screen.width, ScreenWidth);
   end;
   //

end;

procedure TfrmMain.Cheques1Click(Sender: TObject);
begin
  frmCheques:=TfrmCheques.Create(Application);
  frmCheques.ShowModal;
end;

procedure TfrmMain.Emitidos1Click(Sender: TObject);
begin
  frmEmitidos:=TfrmEmitidos.Create(Application);
  frmEmitidos.ShowModal;
end;

procedure TfrmMain.Baixados1Click(Sender: TObject);
begin
frmBaixados:=TfrmBaixados.Create(Application);
frmBaixados.ShowModal;
end;

procedure TfrmMain.Bancos1Click(Sender: TObject);
begin
frmBancos:=TFrmBancos.Create(Application);
frmBancos.ShowModal;
end;

procedure TfrmMain.Agncia1Click(Sender: TObject);
begin
frmAgencias:=TfrmAgencias.Create(Application);
frmAgencias.ShowModal;
end;

procedure TfrmMain.TodososCheques1Click(Sender: TObject);
begin
frmRelCheques:=TfrmRelCheques.Create(Application);
AbreTabela(1);
frmRelCheques.QuickRep1.Preview;
end;

procedure TfrmMain.ConfigurarImpressora1Click(Sender: TObject);
begin
PrinterSetupDialog1.Execute;
end;

procedure TfrmMain.Baixados2Click(Sender: TObject);
begin
frmRelCheques:=TfrmRelCheques.Create(Application);
AbreTabela(2);
frmRelCheques.QuickRep2.Preview;
end;

procedure TfrmMain.Pendentes2Click(Sender: TObject);
begin
frmRelCheques:=TfrmRelCheques.Create(Application);
AbreTabela(3);
frmRelCheques.QuickRep3.Preview;
end;

end.
